Unit Unit1;

{$mode objfpc}{$H+}


Interface

Uses
  Classes, Sysutils, Fileutil, Forms, Controls, Graphics, Dialogs, StdCtrls, Grids, Spin,
  GLZVectorMath;



Type
  { Tform1 }
  Tform1 = Class(Tform)
    Button1 : Tbutton;
    Stringgrid1 : Tstringgrid;
    Procedure Button1click(Sender : Tobject);
    Procedure Formcreate(Sender : Tobject);
  Private

  Public

  End;




Var
  Form1 : Tform1;

Implementation

{$R *.lfm}

{ Tform1 }

Procedure Tform1.Button1click(Sender : Tobject);
Var
  V1, V2, V3 : TGLZVector4f;
  VS1, VS2, VS3 : TGLZSSEVector4f;
  VA1, VA2, VA3 : TGLZAVXVector4f;

  F : Single;
  FR1,FR2,FR3 : Single;
Begin
  F := 1.5;
  v1.Create(5.850,15.480,8.512,0);
  v2.Create(1.558,6.512,4.525,1);

  vS1.Create(5.850,15.480,8.512,0);
  vS2.Create(1.558,6.512,4.525,1);

  vA1.Create(5.850,15.480,8.512,0);
  vA2.Create(1.558,6.512,4.525,1);

  //--------------------
  v3  := v1 + v2;
  vs3 := vs1 + vs2;
  va3 := va1 + va2;
  With StringGrid1 do
  begin
    Cells[1,1] := v3.ToString;
    Cells[2,1] := vS3.ToString;
    Cells[3,1] := vA3.ToString;
  End;
  //--------------------
  v3  := v1 - v2;
  vs3 := vs1 - vs2;
  va3 := va1 - va2;
  With StringGrid1 do
  begin
    Cells[1,2] := v3.ToString;
    Cells[2,2] := vS3.ToString;
    Cells[3,2] := vA3.ToString;
  End;
  //--------------------
  v3  := v1 * v2;
  vs3 := vs1 * vs2;
  va3 := va1 * va2;
  With StringGrid1 do
  begin
    Cells[1,3] := v3.ToString;
    Cells[2,3] := vS3.ToString;
    Cells[3,3] := vA3.ToString;
  End;
  //--------------------
  v3  := v1 / v2;
  vs3 := vs1 / vs2;
  va3 := va1 / va2;
  With StringGrid1 do
  begin
    Cells[1,4] := v3.ToString;
    Cells[2,4] := vS3.ToString;
    Cells[3,4] := vA3.ToString;
  End;

  //--------------------
  v3  := v1 + F;
  vs3 := vs1 + F;
  va3 := va1 + F;
  With StringGrid1 do
  begin
    Cells[1,5] := v3.ToString;
    Cells[2,5] := vS3.ToString;
    Cells[3,5] := vA3.ToString;
  End;
  //--------------------
  v3  := v1 - F;
  vs3 := vs1 - F;
  va3 := va1 - F;
  With StringGrid1 do
  begin
    Cells[1,6] := v3.ToString;
    Cells[2,6] := vS3.ToString;
    Cells[3,6] := vA3.ToString;
  End;
  //--------------------
  v3  := v1 * F;
  vs3 := vs1 * F;
  va3 := va1 * F;
  With StringGrid1 do
  begin
    Cells[1,7] := v3.ToString;
    Cells[2,7] := vS3.ToString;
    Cells[3,7] := vA3.ToString;
  End;
  //--------------------
  v3  := v1 / F;
  vs3 := vs1 / F;
  va3 := va1 / F;
  With StringGrid1 do
  begin
    Cells[1,8] := v3.ToString;
    Cells[2,8] := vS3.ToString;
    Cells[3,8] := vA3.ToString;
  End;
  //--------------------
  v3  := -v1;
  vs3 := -vs1;
  va3 := -va1;
  With StringGrid1 do
  begin
    Cells[1,9] := v3.ToString;
    Cells[2,9] := vS3.ToString;
    Cells[3,9] := vA3.ToString;
  End;
  //--------------------
  v3  := v1.DivideBy2;
  vs3 := vs1.DivideBy2;
  va3 := va1.DivideBy2;
  With StringGrid1 do
  begin
    Cells[1,10] := v3.ToString;
    Cells[2,10] := vS3.ToString;
    Cells[3,10] := vA3.ToString;
  End;
  //--------------------
  FR1  := v1.Distance(v2);
  FR2 := vS1.Distance(vS2);
  FR3 := vA1.Distance(vA2);
  With StringGrid1 do
  begin
    Cells[1,11] := FloatToStrF(FR1,ffFixed,5,5);
    Cells[2,11] := FloatToStrF(FR2,ffFixed,5,5);
    Cells[3,11] := FloatToStrF(FR3,ffFixed,5,5);
  End;
  //--------------------
  FR1  := v1.Length;
  FR2 := vs1.Length;
  FR3 := vA1.Length;
  With StringGrid1 do
  begin
    Cells[1,12] := FloatToStrF(FR1,ffFixed,5,5);
    Cells[2,12] := FloatToStrF(FR2,ffFixed,5,5);
    Cells[3,12] := FloatToStrF(FR3,ffFixed,5,5);
  End;
  //--------------------
  v3  := v1.CrossProduct(v2);
  vs3 := vs1.CrossProduct(vs2);
  va3 := va1.CrossProduct(va2);
  With StringGrid1 do
  begin
    Cells[1,13] := v3.ToString;
    Cells[2,13] := vS3.ToString;
    Cells[3,13] := vA3.ToString;
  End;
  //--------------------
  FR1  := v1.DotProduct(v2);
  FR2 := vs1.DotProduct(vs2);
  FR3 := vA1.DotProduct(vA2);
  With StringGrid1 do
  begin
    Cells[1,14] := FloatToStrF(FR1,ffFixed,5,5);
    Cells[2,14] := FloatToStrF(FR2,ffFixed,5,5);
    Cells[3,14] := FloatToStrF(FR3,ffFixed,5,5);
  End;

    //--------------------
  FR1  := v1.Norm;
  FR2 := vs1.Norm;
  FR3 := vA1.Norm;
  With StringGrid1 do
  begin
    Cells[1,15] := FloatToStrF(FR1,ffFixed,5,5);
    Cells[2,15] := FloatToStrF(FR2,ffFixed,5,5);
    Cells[3,15] := FloatToStrF(FR3,ffFixed,5,5);
  End;
  //--------------------
  v3  := v1.Normalize;
  vs3 := vs1.Normalize;
  va3 := va1.Normalize;
  With StringGrid1 do
  begin
    Cells[1,16] := v3.ToString;
    Cells[2,16] := vS3.ToString;
    Cells[3,16] := vA3.ToString;
  End;

End;

Procedure Tform1.Formcreate(Sender : Tobject);
Begin
  with StringGrid1 do
  begin
    Cells[0,1]  :='V1 + V2 =';
    Cells[0,2]  :='V1 - V2 =';
    Cells[0,3]  :='V1 * V2 =';
    Cells[0,4]  :='V1 / V2 =';
    Cells[0,5]  :='V1 + F =';
    Cells[0,6]  :='V1 - F =';
    Cells[0,7]  :='V1 * F =';
    Cells[0,8]  :='V1 / F =';
    Cells[0,9]  :='-V1 =';
    Cells[0,10] :='V1.DivideBy2 =';
    Cells[0,11] :='V1.Distance(V2) =';
    Cells[0,12] :='V1.Length =';
    Cells[0,13] :='V1.CrossProduct(V2) =';
    Cells[0,14] :='V1.DotProduct(V2) =';
    Cells[0,15] :='V1.Norm =';
    Cells[0,16] :='V1.Normalize =';

  End;
End;






End.

